const __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
  function adopt(value) { return value instanceof P ? value : new P((resolve) => { resolve(value); }); }
  return new (P || (P = Promise))((resolve, reject) => {
    function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
    function rejected(value) { try { step(generator.throw(value)); } catch (e) { reject(e); } }
    function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
const __importDefault = (this && this.__importDefault) || function (mod) {
  return (mod && mod.__esModule) ? mod : { default: mod };
};
Object.defineProperty(exports, '__esModule', { value: true });
exports.useCreateNonceLink = void 0;
const react_1 = __importDefault(require('react'));

function useCreateNonceLink(createNonceLink, config = { params: {} }) {
  const [result, setResult] = react_1.default.useState(null);
  const [loading, setLoading] = react_1.default.useState(false);
  const [error, setError] = react_1.default.useState(null);
  const [isPolling, setIsPolling] = react_1.default.useState(true);
  const cancel = react_1.default.useCallback((broadcast = true) => {
    let _a;
    setIsPolling(false);
    if (broadcast) {
      (_a = config === null || config === void 0 ? void 0 : config.onCancel) === null || _a === void 0 ? void 0 : _a.call(config);
    }
  }, [isPolling]);
  react_1.default.useEffect(() => {
    const doEffect = () => __awaiter(this, void 0, void 0, function* () {
      let _a; let
        _b;
      try {
        setLoading(true);
        const result = yield createNonceLink(config.params);
        setLoading(false);
        setResult(result);
        (_a = config === null || config === void 0 ? void 0 : config.onComplete) === null || _a === void 0 ? void 0 : _a.call(config, result);
        cancel(false);
      } catch (e) {
        setLoading(false);
        console.error(e);
        setError(e);
        (_b = config === null || config === void 0 ? void 0 : config.onError) === null || _b === void 0 ? void 0 : _b.call(config, e);
        cancel(false);
      }
    });
    doEffect();
  }, [JSON.stringify(config.params)]);
  return {
    result,
    loading,
    error,
    cancel,
  };
}
exports.useCreateNonceLink = useCreateNonceLink;
// # sourceMappingURL=useCreateNonceLink.js.map
