Object.defineProperty(exports, '__esModule', { value: true });
exports.useInterval = void 0;
const react_1 = require('react');

function useInterval(callback, delay, enabled = true) {
  const savedCallback = (0, react_1.useRef)(() => { });
  (0, react_1.useEffect)(() => {
    savedCallback.current = callback;
  }, [callback]);
  (0, react_1.useEffect)(() => {
    function tick() {
      let _a;
      (_a = savedCallback.current) === null || _a === void 0 ? void 0 : _a.call(savedCallback);
    }
    let id;
    if (enabled && delay !== null) {
      id = setInterval(tick, delay);
    }
    return () => clearInterval(id);
  }, [delay, enabled]);
}
exports.useInterval = useInterval;
// # sourceMappingURL=useInterval.js.map
