const __importDefault = (this && this.__importDefault) || function (mod) {
  return (mod && mod.__esModule) ? mod : { default: mod };
};
Object.defineProperty(exports, '__esModule', { value: true });
exports.useNonceSocket = void 0;
const socket_io_client_1 = __importDefault(require('socket.io-client'));
const react_1 = __importDefault(require('react'));
const sdk_1 = require('@bedrock-foundation/sdk');

function useNonceSocket(config) {
  const [data, setData] = react_1.default.useState(null);
  const [error, setError] = react_1.default.useState(null);
  react_1.default.useEffect(() => {
    if (config.nonce) {
      const newSocket = (0, socket_io_client_1.default)(config.bedrock.basePath);
      const nonceSocketTopic = (0, sdk_1.createNonceSocketTopic)(config.nonce);
      newSocket.on('connect', () => {
        newSocket.on(nonceSocketTopic, (data) => {
          let _a;
          setData(data);
          (_a = config.onChange) === null || _a === void 0 ? void 0 : _a.call(config, data);
        });
        newSocket.once('error', (error) => {
          let _a;
          setError(error);
          (_a = config === null || config === void 0 ? void 0 : config.onError) === null || _a === void 0 ? void 0 : _a.call(config, error);
        });
      });
      return () => {
        newSocket.close();
      };
    }
    return () => { };
  }, [config.nonce, config.bedrock.basePath]);
  return {
    data,
    error,
  };
}
exports.useNonceSocket = useNonceSocket;
// # sourceMappingURL=useNonceSocket.js.map
