const __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
  function adopt(value) { return value instanceof P ? value : new P((resolve) => { resolve(value); }); }
  return new (P || (P = Promise))((resolve, reject) => {
    function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
    function rejected(value) { try { step(generator.throw(value)); } catch (e) { reject(e); } }
    function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
const __importDefault = (this && this.__importDefault) || function (mod) {
  return (mod && mod.__esModule) ? mod : { default: mod };
};
Object.defineProperty(exports, '__esModule', { value: true });
exports.usePollReferenceStatus = void 0;
const react_1 = __importDefault(require('react'));
const useInterval_1 = require('./useInterval');

const DEFAULT_INTERVAL = 5000;
function usePollReferenceStatus(getReferenceStatus, config) {
  let _a;
  const [data, setData] = react_1.default.useState(null);
  const [error, setError] = react_1.default.useState(null);
  const [isPolling, setIsPolling] = react_1.default.useState(true);
  const cancel = react_1.default.useCallback((broadcast = true) => {
    let _a;
    setIsPolling(false);
    if (broadcast) {
      (_a = config === null || config === void 0 ? void 0 : config.onCancel) === null || _a === void 0 ? void 0 : _a.call(config);
    }
  }, [isPolling]);
  (0, useInterval_1.useInterval)(() => __awaiter(this, void 0, void 0, function* () {
    let _b; let
      _c;
    try {
      const data = yield getReferenceStatus({ ref: config.ref });
      if (data.signature !== null) {
        setData(data);
        (_b = config === null || config === void 0 ? void 0 : config.onComplete) === null || _b === void 0 ? void 0 : _b.call(config, data);
        cancel(false);
      }
    } catch (e) {
      console.error(e);
      setError(e);
      (_c = config === null || config === void 0 ? void 0 : config.onError) === null || _c === void 0 ? void 0 : _c.call(config, e);
      cancel(false);
    }
  }), (_a = config.interval) !== null && _a !== void 0 ? _a : DEFAULT_INTERVAL, isPolling);
  return {
    data,
    error,
    cancel,
  };
}
exports.usePollReferenceStatus = usePollReferenceStatus;
// # sourceMappingURL=usePollReferenceStatus.js.map
